/* Copyright 2007 Universidade Federal do Rio Grande do Sul
   Carlos Dietrich - cadietrich@inf.ufrgs.br

   This copy is GPLv2 or later, your choice. */

#ifndef MARCHINGCUBES_INCLUDED
#define MARCHINGCUBES_INCLUDED

#include <map>
#include <vector>

#include <IMarchingMethod.h>

class CMarchingCubes
	: public IMarchingMethod
{
public:
	CMarchingCubes(void);
	~CMarchingCubes(void);
	bool GenerateMesh(float isoLevel);
protected:
	void SetupVertexPool(void);
private:
	int GenerateVertex(float x, float y, float z, int edgeName);
	inline int GetEdgeId(int x, int y, int z, int edgeName) const;
	inline int GetVertexId(int x, int y, int z) const;
	void RenameElements(void);
protected:
	std::map<int, int> m_vertexToEdgeMap;
	static const int m_edgeTable[256];
	static const int m_triangleTable[256][16];
};

#endif // MARCHINGCUBES_INCLUDED

