/* Copyright 2007 Universidade Federal do Rio Grande do Sul
   Carlos Dietrich - cadietrich@inf.ufrgs.br

   This copy is GPLv2 or later, your choice. */

#ifndef VERTEXPOOL_INCLUDED
#define VERTEXPOOL_INCLUDED

#include <vector>
#include <string>

#include <boost/utility.hpp>

// Struct?
class CVertexPool 
	: boost::noncopyable
{
public:
	enum STREAM_FORMAT {
		OFF,
		PLY
	};
	enum POLYGON_MODE {
		POINTS = 0x0000,
		LINES = 0x0001,
		LINE_LOOP = 0x0002,
		LINE_STRIP = 0x0003,
		TRIANGLES = 0x0004,
		TRIANGLE_STRIP = 0x0005,
		TRIANGLE_FAN = 0x0006,
		QUADS = 0x0007,
		QUAD_STRIP = 0x0008,
		POLYGON = 0x0009
	};
	CVertexPool(void);
	~CVertexPool(void);
	virtual void Clear(void);
	bool Draw(void) const;
	bool Save(const std::string fileName, STREAM_FORMAT type, bool saveColor) const;
protected:
	virtual void Create(void);
public:
	int m_vertexSize;
	std::vector<float> m_vertexArray;
	int m_colorSize;
	std::vector<float> m_colorArray;
	std::vector<float> m_normalArray;
	int m_texCoordSize;
	std::vector<float> m_texCoordArray;
	unsigned int m_mode;
	std::vector<unsigned int> m_elementArray;
};

#endif // VERTEXPOOL_INCLUDED

